diff -r 3b0ff2c27f2c sys/src/9/pc/archacpi.c
--- a/sys/src/9/pc/archacpi.c	Tue Jul 09 17:41:25 2013 +0400
+++ b/sys/src/9/pc/archacpi.c	Fri Jul 12 22:55:02 2013 +0400
@@ -41,6 +41,17 @@
 	Tblsz	= 4+4+1+1+6+8+4+4+4,
 };
 
+enum { 
+	FadtSmi = 12,
+	FadtAcpiEn = 16,
+	FadtPstateCnt = 19
+};
+
+enum {
+	GoFullRetard = 1
+};
+
+static int acpimode;
 static Rsd *rsd;
 
 /* physical addresses visited by maptable() */
@@ -66,6 +77,18 @@
 	free(p);
 }
 
+void 
+amlio(uchar, char, uvlong *buf, uvlong, int len){
+	/* we don't do AML io in the kernel */
+	memset(buf, 0, len);
+	return;
+}
+
+void 
+amldelay(int n){
+	microdelay(n);
+}
+
 static ushort
 get16(uchar *p){
 	return p[1]<<8 | p[0];
@@ -464,6 +487,20 @@
 	 * Ininitalize local APIC and start application processors.
 	 */
 	mpinit();
+
+	/* enable acpi */
+	if(acpimode != GoFullRetard)
+		return;
+	for(i=0; i<ntblmap; i++){
+		t = tblmap[i];
+		if(memcmp(t->sig, "FACP", 4) == 0){
+			p = t->data;
+			print("smi_cmd: 0x%x acpi_enable: 0x%x pstate_cnt: 0x%x\n",
+				get32(&p[FadtSmi]), p[FadtAcpiEn], p[FadtPstateCnt]);
+			outb(get32(&p[FadtSmi]), p[FadtAcpiEn]);
+			break;
+		}
+	}	
 }
 
 static int identify(void);
@@ -480,6 +517,33 @@
 .timerset=	lapictimerset,
 };
 
+/* ACPI backdoor */
+static long
+readacpimem(Chan*, void *v, long n, vlong off)
+{
+	void *p;
+
+	p = vmap(off, n);
+	if(p == nil)
+		return 0;
+	memmove(v, p, n);
+	vunmap(p, n);
+	return n;
+}
+
+static long
+writeacpimem(Chan*, void *a, long n, vlong off)
+{
+	void *p;
+
+	p = vmap(off, n);
+	if(p == nil)
+		return 0;
+	memmove(p, a, n);
+	vunmap(p, n);
+	return n;
+}
+
 static long
 readtbls(Chan*, void *v, long n, vlong o)
 {
@@ -515,11 +579,15 @@
 
 	if((cp = getconf("*acpi")) == nil)
 		return 1;
+	if(strcmp(cp, "2") == 0)
+		acpimode = GoFullRetard;
 	if((rsd = sigsearch("RSD PTR ")) == nil)
 		return 1;
 	if(checksum(rsd, 20) && checksum(rsd, 36))
 		return 1;
 	addarchfile("acpitbls", 0444, readtbls, nil);
+	if(acpimode == GoFullRetard)
+		addarchfile("acpimem", 0664, readacpimem, writeacpimem);
 	if(strcmp(cp, "0") == 0)
 		return 1;
 	if((cp = getconf("*nomp")) != nil && strcmp(cp, "0") != 0)
